Subject: Re: [bitcoin-dev] Trinary Version Signaling for softfork

From: <[email-masked]>
Date: Wed, 30 Jun 2021 02:17:08 -0700

Hi Prayank,

> So majority hash power not following the consensus rules can result in chain split?

Any two people on different rules implies a chain split. That’s presumably why rule changes are called forks. There is no actual concept of “the rules” just one set of rules or another.

> Why would majority of miners decide to mine a chain that nobody wants to use?

I don’t presume to know why people prefer one thing over another, or what people want to use, nor does economics.

> What are different things possible in this case based on game theory?

I’ve seen no actual demonstration of the relevance of game theory to Bitcoin. People throw the words around quite a bit, but I can’t give you an answer because I have found no evidence of a valid game theoretic model applicable to Bitcoin. It’s not a game, it’s a market.

> Do miners and mining pools participate in discussions before signaling for a soft fork begins?

Who knows, I don’t get invited to round table meetings.

> Can they still mine something else post activation even if signaling readiness for soft fork? 

A person can mine whatever they want. Signaling does not compel a miner to enforce. Each block mined is anonymous. But each miner seeing the signals of others, unless they are coordinating, would presumably assume that others will enforce.

> Who enforces consensus rules technically in Bitcoin? Full nodes or Miners?

A node (software) doesn’t enforce anything. Merchants enforce consensus rules when they reject trading for something that they don’t consider money. Every time two people trade both party validates what they receive (not what they trade away). Those receiving Bitcoin are economically relevant and their power is a function of how much they are doing so.

Miners censor, which is inconsequential unless enforced. Majority miners can enforce censorship by simply not building on any non-censoring blocks. This is what soft fork enforcement is.

> Is soft fork signaling same as voting?

I don’t see that it needs a label apart from signaling. There are many kinds of voting. It would be hard to equate signaling with any of them. It’s a public signal that the miner who mined a given block miner intends to censor, that’s all.

> According to my understanding, miners follow the consensus rules enforced by full nodes and get (subsidy + fees) for their work.

Miners mine a chain, which ever one they want. There are many. They earn the block reward.

> Signaling is not voting although lot of people consider it voting including some mining pools and exchanges.

What people consider it is inconsequential. It has clearly defined behavior.

e

From: Prayank <[email-masked]> 
Sent: Sunday, June 27, 2021 5:01 AM
To: [email-masked]
Cc: Bitcoin Dev <[email-masked]>
Subject: Re: [bitcoin-dev] Trinary Version Signaling for softfork

Hello Eric,

I have few questions:

> Without majority hash power support, activation simply means you are off on a chain split. 

So majority hash power not following the consensus rules can result in chain split? Why would majority of miners decide to mine a chain that nobody wants to use? What are different things possible in this case based on game theory? 

> And activation without majority hash power certainly does not “ensure” this.

Do miners and mining pools participate in discussions before signaling for a soft fork begins? Can they still mine something else post activation even if signaling readiness for soft fork? 

> If one wants to enforce a soft fork (or otherwise censor) this is accomplished by mining (or paying others to do so). Anyone can mine, so everyone gets a say. Mining is trading capital now for more later. If enough people want to do that, they can enforce a soft fork. It’s time Bitcoiners stop thinking of miners as other people. Anyone can mine, and that’s your vote.

Who enforces consensus rules technically in Bitcoin? Full nodes or Miners?

Is soft fork signaling same as voting?

According to my understanding, miners follow the consensus rules enforced by full nodes and get (subsidy + fees) for their work. Signaling is not voting although lot of people consider it voting including some mining pools and exchanges.

-- 

Prayank